//************************************************************
//  University of Patras 
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI 
//	Week 01: Code Optimization
//
//  Description: Optimization effects
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 9.3
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc ex3.c -o ex3
Executing:	time ./ex3

*/

// **************************************************************

#include <stdio.h>
#include <stdlib.h>

#define N	10000

int A[N][N] ;
int B[N][N] ;
int C[N][N] ;

// ***************************************************************************
void setValMat( int *a )
{
	int i, q = N*N ;
	for( i = 0 ; i < q ; i++ )
		    *a++ = (rand() % 100) - 50 ;

}

// ***************************************************************************
void addMat( int *a, int *b, int *c )
{
	int i;

	for( i = 0 ; i < N*N ; i++ )
		    *c++ = *a++ + *b++ ;

}

// ***************************************************************************
int innerProdMat( int *a, int *b )
{
	int i, sum = 0 ;

	for( i = 0 ; i < N*N ; i++ )
		    sum += *a++ * *b++ ;

	return sum ;
}



// **************************************************************
int main(void)
{
double t1, t2, ttot = 0, t ;
int res ;

	setValMat( (int *)A ) ;
	setValMat( (int *)B ) ;
	addMat( (int *)A, (int *)B, (int *)C ) ;
	res = innerProdMat( (int *)A, (int *)C ) ;
	printf( "innerProdMat  %d\n", res ) ;

	return 0 ;
}
